---
title: GIT
authors:
  - Marek Chalupa
  - Vladimír Štill
date: 15\. září 2017
header-includes:
    - \institute{FAKOS}
theme: metropolis
lang: czech
...


## Verzované složky / lokální verzovací systém
 * Jednoduché, ale neefektivní a nepraktické
 * Jak spolupracovat s ostatními lidmi?


 \begin{center}
 \vspace{3mm}
 \includegraphics[width=6cm]{folders.png}
 \end{center}



## Centrální verzovací systém
 * Server je bottle-neck
 * Co když není internetové spojení?


 \begin{center}
 \includegraphics[width=6cm]{centralized.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/centralized.png}}}
 \end{center}

## Distribuovaný verzovací systém
 * Každý počítač (klient i server) má celou kopii repozitáře

 \begin{center}
 \includegraphics[width=5cm]{distributed.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/distributed.png}}}
 \end{center}

## GIT
 * Distribuovaný verzovací systém
 * Většina operací jsou lokální
 * Snímky souborového systému ("snapshot"), neukládá rozdíly
 * "Commit often, perfect later, publish once."

## GIT -- pozadí
 * Git sleduje danou složku a soubory v ní
 * Soubor je buď sledovaný nebo nesledovaný (tracked/untracked)
 * Každý sledovaný soubor může být ve třech stavech:
     - unmodified / modified / staged

 \begin{center}
 \includegraphics[width=6cm]{lifecycle.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/lifecycle.png}}}
 \end{center}

## První tři příkazy
 * `git init` -- initializuj repozitář v prázdné složce
 * `git add`  -- přidej obsah do následujícího commitu
 * `git commit` -- vytvoř commit

 \begin{center}
 \includegraphics[width=6cm]{areas.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/areas.png}}}
 \end{center}






